# distance.py

import string

#======================================================================               
roues = [ 26, 25, 23, 21, 19, 17 ]

alpha_roues = [
  "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
  "ABCDEFGHIJKLMNOPQRSTUVXYZ",
  "ABCDEFGHIJKLMNOPQRSTUVX",
  "ABCDEFGHIJKLMNOPQRSTU",
  "ABCDEFGHIJKLMNOPQRS",
  "ABCDEFGHIJKLMNOPQ"
]
constC38 = [
	89705175,
	56787276,
	92587950,
	82090450,
	42697200,
	41755350
]
#======================================================================
def calpos( cle ):
	total = 0
	for i in range( len(cle) ):
		indx = alpha_roues[i].find( cle[i] )
		v = constC38[i] * ( indx + 1 )
		total += v
	return (total % 101405850) - 1

def calpos2( cle ):
	for position in range(101405850):
		if (position % 1000000) == 0: print position
		clep = calcle( position )
		if clep == cle :
			return position
	return -1

def calcle( position ):
	cle = ""
	for i in range(6):
		indx = position % roues[i]
		cle += alpha_roues[i][ indx ]
	return cle

def incr( position ):
	position +=1
	position %= 101405850
	return position
#======================================================================
if __name__ == "__main__":
  position = 0
  while True:
	print "\n=======> position: ", position
	print "1 - calculate position from a key (Wayne Barker method)"
	print "2 - calculate key from current position"
	print "3 - set position"
	print "4 - print several external keys"
	print "5 - calculate position (exhaustive method)"
	print "99- END"
	choix = raw_input("choice ? ")

	if choix == "1":
		cle = raw_input("key ? ").strip()
		position =  calpos( cle )
		print position 

	if choix == "2":
		print calcle( position )
	
	if choix == "3":
		position = int(raw_input("Position ?" ))		

	if choix == "4":
		while True:
			for i in range(10):
				cle = calcle( position )
				print cle, position
				position = incr( position )
			ch = raw_input("Continue (q=quit) ? ")
			if ch == "q":
				break

	if choix == "5":
		cle = raw_input("key ? ").strip()
		position =  calpos2( cle )
		print position 			

	if choix == "99":
		break
