#!/usr/bin/python
# proba_word.py
# v1.0 2015 Nov 03 - 
# print string corresponding to probable word when messages iare in depth

import sys
import string
import math
import getopt

# ===================================
def is_maj(car):

        if string.find(string.ascii_uppercase,car) == -1:
                return 0
        else:
                return 1

#===========fic2ch =====================
def fic2ch(f, offset):
        chaine = "" ; lg = 0
        while True:
                ch = f.readline()
                ligne = ""
                if ch == "":
                        break
                for i in range( len(ch) ):
                        if is_maj( ch[i] ):
                                ligne += ch[i] ; lg += 1
                chaine += ligne
        return chaine[offset:], lg-offset

#=======================================
def usage():
    print "usage: ", sys.argv[0], " [option...] cipher1[:off] cipher2[:off]"
    print "  -T trig    The file which contains Trigrams statistics"
    print "  -d dict    The file which contains dictionary"
    print "  -p pw      The probable word (not compatible with -d)"
    print "  -t thr     The threshold (by default 0)"
    print "  -Z         Frame words of a dictionary with letter Z"
    print "  -z         Replace each letter Z by a dot in the string found"
    print "  -D         Debug mode"
    print "  -h         Help"

#======================================
try:
  opts, args = getopt.getopt(sys.argv[1:],
    "hDT:d:p:t:Zz", ["help", "Debug", "trigram=","dictionary=",
    "probable_word=", "treshold=", "zframed", "zspace"])
except getopt.GetoptError as err:
  print sys.argv[0],": ", str(err) # option -a not recognized"
  usage()
  sys.exit(2)

SEUIL=0
DEBUG=0
FLAGZ=0
FLAG_SP=0
PROBWORD=""
dictionary_file=""

for o, a in opts:
  if o == "-D":
    DEBUG=1
  elif o in ("-h", "--help"):
    usage()
    sys.exit()
  elif o in ("-T", "--trigram"):
    trigram_file = a
  elif o in ("-d", "--dictionary"):
    dictionary_file = a
  elif o in ("-p", "--probable_word"):
    PROBWORD = a
  elif o in ("-t", "--threshold"):
    SEUIL=float(a)
  elif o in ("-Z", "--zframed"):
    FLAGZ = 1
  elif o in ("-z", "--zspace"):
    FLAG_SP = 1
  else:
    assert False, "unhandled option"
if (dictionary_file == "" and PROBWORD == "") or \
   (dictionary_file != "" and PROBWORD != ""):
  usage()
  sys.exit(1)
#============================================================
if args[0].find(":") != -1:
    ch1,ch2 = args[0].split(":")
else:
    ch1 = args[0] ; ch2 = "0"
try:
    fcry1 = open( ch1, "r")
    off1  = int(  ch2 )
except IOError:
    print "ERROR: the file ", ch1, " cannot be open"
    sys.exit(1)
if args[1].find(":") != -1:
    ch1,ch2 = args[1].split(":")
else:
    ch1 = args[1] ; ch2 = "0"
try:
    fcry2 = open( ch1, "r")
    off2  = int(  ch2 )
except IOError:
    print "ERROR: the file ", ch1, " cannot be open"
    sys.exit(1)

cry1, lg1 = fic2ch( fcry1 , off1 )
cry2, lg2 = fic2ch( fcry2 , off2 )

#---- search the smallest file
lg = lg1
if lg1 > lg2:
        lg = lg2

#=========== Dictionary ==================
if dictionary_file != "":
    try:
        fmc = open( dictionary_file, "r")
    except IOError:
        print "ERROR: the file ", dictionary_file, " cannot be open"
        sys.exit(1)
        
#===========Trigrammes=====================
lesTri = {}

try:
    f_tri = open( trigram_file ,"r")
except IOError:
    print "ERROR: the file ", trigram_file, " cannot be open"
    sys.exit(1)
        
while 1:
        ch = f_tri.readline()
        if ch == "": break
        ch = ch.strip()
        (tri,fre) = ch.split(',')
        lesTri[ tri ] = math.log(int(fre))

cryptos = []
cryptos.append( cry1[:lg] )
cryptos.append( cry2[:lg] )
if DEBUG :
	print "cryptos: ====> \n", cryptos
motcles = []
if  PROBWORD != "":
    motcles.append( PROBWORD.upper() )
else:
    while True:
        ch = fmc.readline().upper()
        if ch == "": break
        ch = ch.strip()
        if FLAGZ:
            ch = "Z" + ch.upper() + "Z"
        motcles.append( ch.strip() )

#>>>>>>>>>>>>>>>>>>>>> Begin <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
result = {}

for unMotCle in motcles:
  cle = [0] * len(unMotCle)
  for uneLigne in range(2):
    maxi = 0
    for i in range( len(cryptos[0])-len(unMotCle) ):
      for j in range( len(unMotCle) ):
        cle[j] = (ord(unMotCle[j])-65 + ord(cryptos[uneLigne][i+j])-65)%26
      bouchif = cryptos[uneLigne][i:i+j+1]
      hypo = ""
      for j in range( len(unMotCle) ):
        lettre  = string.uppercase.index( cryptos[(uneLigne+1)%2][i+j]  )
	chiffre = string.uppercase[ (26 + cle[j] - lettre )%26 ]
        hypo += chiffre
      total = 0
      for j in range( len(unMotCle)-2 ):
        tri = hypo[j:j+3]
        if tri in lesTri:
          v = lesTri[ tri ]
        else:
          v = 1.0
        total +=  v
      total /= len(unMotCle)
      if total >= SEUIL:
        if FLAG_SP:
            hypo = hypo.replace("Z",".")
        enreg = (  total, unMotCle, hypo, bouchif, uneLigne, i )
        result[  total ] = enreg
      
print "Score  Probable_Word   String_found    Cipher_text        Msg Position"
for k in sorted( result.keys() ):
    total, unMotCle, hypo, bouchif, uneLigne, i = result[k]
    print "%6.1f %-15s %-15s %-15s %4d %4d" % \
           (total, unMotCle, hypo, bouchif, uneLigne, i)
 
