# scan_HC.py
# try to find the External Key by Hill Climbing Method
# the algorithm was designed by George Lasry
import sys
import string
import random
from m209 import *
from bib_util import *
from ic import IC
#===============================================================
Wheels = [
   "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
   "ABCDEFGHIJKLMNOPQRSTUVXYZ",
   "ABCDEFGHIJKLMNOPQRSTUVX",
   "ABCDEFGHIJKLMNOPQRSTU",
   "ABCDEFGHIJKLMNOPQRS",
   "ABCDEFGHIJKLMNOPQ"
]
#===============================================================
THREHOLD=0.065
START_LETTER=0
if len(sys.argv) < 2:
    print "usage: scan_HC.py key_file < cipher_text"
    print "       you must neglect the extension '.key'"
    sys.exit(1)
c = Hagelin('Z',0)
try:
    restore(c,sys.argv[1])
except:
    print "ERROR: perhaps you have put on the extension (.key) ? "
    sys.exit(1)
#--------------------------------------
leTexte = sys.stdin.readlines()
clair = ""
for i in range(len(leTexte)):
    ch = leTexte[i]
    ch = ch.upper()
    for j in range(len(ch)):
        if not is_maj(ch[j]):
            continue
        clair = clair + ch[j]
print clair
#===============================================================
IC_PRINT = 0
for i in range(22255):
   # 1. on prend une valeur aleatoire des roues
   wheel_start = ""
   for roue in range(6):
       #print Wheels[roue], len(Wheels[roue]), random.randint(0,len(Wheels[roue]))
       wheel_start = wheel_start + Wheels[roue][ random.randint(0,len(Wheels[roue] ))-1 ]
       #print ">>>>>>>>>> Essai: ", i, "Start: ", wheel_start

   # 2. Decrypt, compute IC
   externalkey = wheel_start
   c.setExternalKey(externalkey)
   crypto = chiffre(c, clair)
   #print crypto
   IC_START = IC( crypto )
   #bestPos = "A"
   #print ">>>>>>>>>>>>>>>>IC: ", IC_START, "Wheel start: ", wheel_start

   for j in range(2):
    # 3. For each wheel from 1 to 6
    for roue in range(6):
        # 3.1 For each position in current wheel
        start = wheel_start
        bestPos = wheel_start[roue]
        bestIC = IC_START
        for posWheel in Wheels[roue]:
            # 3.1.1 Set starting position of the wheel to that position
            externalkey = start[0:roue] + posWheel + start[roue+1:]
            #print roue, externalkey

            # 3.1.2 Decrypt, compute IC
            c.setExternalKey(externalkey)
            crypto = chiffre(c, clair)
            #print crypto
            val = IC( crypto )

            # 3.1.3 If higher than IC so far, remember it as the best starting
            #       position for the current wheel.
            if ( val > bestIC ) :
                #print "IC best:", val, " Roue: ", roue, "  Pos: ", posWheel
                bestPos = posWheel
                bestIC = val

        # 3.2 Take the best starting position of current wheel
        wheel_start = wheel_start[0:roue] + bestPos + wheel_start[roue+1:]
        IC_START = bestIC
        #print "ROUE: ", roue, "star:", wheel_start, "IC: ", IC_START

    if ( bestIC >  IC_PRINT ):
        print "Try:", i, "IC best:", bestIC, "  Key:", wheel_start, " Crypto:"
        c.setExternalKey(wheel_start)
        crypto = chiffre(c, clair)
        print crypto
        IC_PRINT = bestIC
