# superimpose.py
# affiche une mesure de superposition (un IC?)
# au moins 50 car de superposition

import sys
import string
import math

# ===================================
def is_maj(car):

    if string.find(string.ascii_uppercase,car) == -1: 
        return 0
    else:
        return 1
#===========fic2ch =====================
def fic2ch(f):
    chaine = "" ; lg = 0
    while True:
        ch = f.readline()
        ligne = ""
        if ch == "":
            break
        for i in range( len(ch) ):
            if is_maj( ch[i] ):
                ligne += ch[i] ; lg += 1
        chaine += ligne    
    return chaine, lg
#=======================================
#>>>>>>>>>>>> Debut programme

if len(sys.argv) < 2 :
    print "Syntaxe: super.py crypto1 crypto2 [IC_threhold [length super]]"
    print "         by default, the IC_threhold is 0.055"
    print "         by default, the length of superimposition is 50 letters"
    sys.exit(1)
if len(sys.argv) > 3 :
    SEUIL = float(sys.argv[3])
else:
    SEUIL = 0.055
if len(sys.argv) > 4:
    lgsuper = int(sys.argv[4])
else:
    lgsuper = 50
try:
    fcry1 = open( sys.argv[1], "r")
    fcry2 = open( sys.argv[2], "r")
except IOError:
    print "ERROR: impossible to open a cipher text"
    sys.exit(1)
cry1, lg1 = fic2ch( fcry1 )
cry2, lg2 = fic2ch( fcry2 )

#---- recherche du plus petit
lg = lg1
lgmax = lg2
if lg1 > lg2:
    lg = lg2 
    lgmax = lg1
    crybis = cry1
    cry1 = cry2
    cry2 = crybis
    lg2 = lg1
    lg1 = lg
print "lenght: ", lg1, lg2, " smallest: ", lg

#---- combien d'iteration ?
if lg <= lgsuper:
    print "ERROR: messages are too small"
    sys.exit(1)
niters = (lgmax - lgsuper) +  (lg - lgsuper) 
#=====

print "Coincidences   IC   length_msg offset-1 offset-2 length_super"
for iter in range(niters):
    super = -1
    if iter < (lg - lgsuper):
        off1 = (lg - lgsuper) - iter
        super = lg - off1
    else:
        off1 = 0
    if iter == (lg - lgsuper):
        off1 = 0
        off2 = 0
        super = lg
    if iter > (lg - lgsuper):
        off2 = iter - (lg - lgsuper) 
        if off2 > ( lg2 - lg):
            super = lg - ( off2 - (lg2 - lg ))
        else:
            super = lg
    else:    
        off2 = 0

    coincidences = 0
    for i in range(super):
        #print off1, off2, super, lg2 - lg, i
        if cry1[i + off1 ] == cry2[i + off2 ]:
            coincidences += 1
    ic = float(coincidences) / float(super)
    if ic > SEUIL :
        print "%4d           %6.4f    %5d    %5d    %5d        %5d" \
            % (coincidences, ic, lg, off1, off2, super)

