# superpimpose.py
# affiche une mesure de superpposition (un IC?)
# au moins 50 car de superpposition

import sys
import string
import math

# ===================================
def is_maj(car):

    if string.find(string.ascii_uppercase,car) == -1: 
        return 0
    else:
        return 1
#===========fic2ch =====================
def fic2ch(f):
    chaine = "" ; lg = 0
    while True:
        ch = f.readline()
        ligne = ""
        if ch == "":
            break
        for i in range( len(ch) ):
            if is_maj( ch[i] ):
                ligne += ch[i] ; lg += 1
        chaine += ligne    
    return chaine, lg
#=======================================
def bambu( M, N):
    # M is the number of coincidences
    # N is the length of superpimposition
    P = 0.0667 
    #IC English,0.0667, French,0.0778. German,0.0762, Spanish,0.0770.
    BF = ((P ** M) * ((1-P)**(N-M)))  / (((1./26)**M)*((25./26)**(N-M)))
    BFdB = int(  20 * math.log (BF ))
    return BFdB
#=======================================
#>>>>>>>>>>>> Debut programme

if len(sys.argv) < 2 :
    print "Syntaxe: superp.py crypto1 crypto2 [IC_threhold [length superp]]"
    print "         by default, the IC_threhold is 0.055"
    print "         by default, the length of superpimposition is 50 letters"
    sys.exit(1)
if len(sys.argv) > 3 :
    SEUIL = float(sys.argv[3])
else:
    SEUIL = 0.055
if len(sys.argv) > 4:
    lgsuperp = int(sys.argv[4])
else:
    lgsuperp = 50
try:
    fcry1 = open( sys.argv[1], "r")
    fcry2 = open( sys.argv[2], "r")
except IOError:
    print "ERROR: impossible to open a cipher text"
    sys.exit(1)
cry1, lg1 = fic2ch( fcry1 )
cry2, lg2 = fic2ch( fcry2 )

#---- recherche du plus petit
lg = lg1
lgmax = lg2
if lg1 > lg2:
    lg = lg2 
    lgmax = lg1
    crybis = cry1
    cry1 = cry2
    cry2 = crybis
    lg2 = lg1
    lg1 = lg
print "lenght: ", lg1, lg2, " smallest: ", lg

#---- combien d'iteration ?
if lg <= lgsuperp:
    print "ERROR: messages are too small"
    sys.exit(1)
niters = (lgmax - lgsuperp) +  (lg - lgsuperp) 
#=====

print "Coincidences   IC   length_msg offset-1 offset-2  Bambu big length_superp"
for iter in range(niters):
    superp = -1
    if iter < (lg - lgsuperp):
        off1 = (lg - lgsuperp) - iter
        superp = lg - off1
    else:
        off1 = 0
    if iter == (lg - lgsuperp):
        off1 = 0
        off2 = 0
        superp = lg
    if iter > (lg - lgsuperp):
        off2 = iter - (lg - lgsuperp) 
        if off2 > ( lg2 - lg):
            superp = lg - ( off2 - (lg2 - lg ))
        else:
            superp = lg
    else:    
        off2 = 0

    coincidences = 0
    for i in range(superp):
        #print off1, off2, superp, lg2 - lg, i
        if cry1[i + off1 ] == cry2[i + off2 ]:
            coincidences += 1
    ic = float(coincidences) / float(superp)
    bigrammes = 0
    for i in range(superp-1):
        if (cry1[i+off1]==cry2[i+off2])and(cry1[i+off1+1]==cry2[i+off2+1]):
            bigrammes += 1
    deciBAN = bambu( coincidences, superp)
    if ic > SEUIL :
        print "%4d           %6.4f    %5d    %5d    %5d  %6.1f %1d %5d" \
        % (coincidences, ic, lg, off1, off2, deciBAN, bigrammes, superp)

